# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/opensaml/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

Name:           opensaml
Version:        1.1b
Release:        2%{?dist}
Epoch:          0
Summary:        Open source implementation of the SAML 1.0 and 1.1 specifications
URL:            http://www.opensaml.org/
License:        ASL 2.0
Group:          Development/Libraries/Java
Source0:        %{name}-%{version}.tgz
Source1:        opensaml-component-info.xml
Requires:       jakarta-commons-codec >= 0:1.3
Requires:       jakarta-commons-logging >= 0:1.0.4
Requires:       log4j >= 0:1.2.8
Requires:       servlet_2_4_api
Requires:       xalan-j2 >= 0:2.6.0
Requires:       xerces-j2 >= 0:2.6.2
Requires:       xml-commons-jaxp-1.3-apis >= 0:1.3.02
Requires:       xml-commons-resolver11 >= 0:1.1
Requires:       xml-security >= 0:1.2.1
BuildRequires:  ant >= 0:1.6.2
BuildRequires:  ant-junit >= 0:1.6.2
BuildRequires:  junit >= 0:3.8
BuildRequires:  jakarta-commons-codec >= 0:1.3
BuildRequires:  jakarta-commons-logging >= 0:1.0.4
BuildRequires:  log4j >= 0:1.2.8
BuildRequires:  servlet_2_4_api
BuildRequires:  xalan-j2 >= 0:2.6.0
BuildRequires:  xerces-j2 >= 0:2.6.2
BuildRequires:  xml-commons-jaxp-1.3-apis >= 0:1.3.02
BuildRequires:  xml-commons-resolver11 >= 0:1.1
BuildRequires:  xml-security >= 0:1.2.1
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
OpenSAML is a set of open source Java and C++ libraries that implement the
SAML 1.0 and 1.1 specifications.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{name}
find . -name "*.jar" | xargs -t rm
pushd java
build-jar-repository endorsed \
                                        xalan-j2 \
                                        xerces-j2 \
                                        xml-commons-jaxp-1.3-apis \
                                        xml-commons-resolver11

build-jar-repository lib \
                                        jakarta-commons-codec \
                                        jakarta-commons-logging \
                                        junit \
                                        log4j \
                                        servlet_2_4_api \
                                        xalan-j2 \
                                        xml-security

# Uncomment the line below to show output... do we really want to see test 
# output though? since haltonerror is true, any failed test will abort build 
# anyways, so it won't be missed.
#sed -i -e s:'<junit printsummary="no" fork="yes" haltonfailure="yes" haltonerror="yes" dir="${root}">':'<junit printsummary="yes" fork="yes" haltonfailure="yes" haltonerror="yes" dir="${root}">':g build.xml
popd

%build
pushd java
export CLASSPATH=
export OPT_JAR_LIST="`%{__cat} %{_sysconfdir}/ant.d/junit`"
%{ant} dist javadocs
popd

%install
rm -rf $RPM_BUILD_ROOT

pushd java
# main package
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 644 dist/opensaml-1.1.jar $RPM_BUILD_ROOT%{_javadir}/opensaml-%{version}.jar
ln -s opensaml-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/opensaml.jar

# javadoc
install -d -m 755 $RPM_BUILD_ROOT/%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT/%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT/%{_javadocdir}/%{name}

%if %with repolib
%{__install} -d -m 755 %{buildroot}%{repodir}
%{__install} -d -m 755 %{buildroot}%{repodirlib}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml
%{__install} -d -m 755 %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/opensaml.jar
%endif
popd

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(0644,root,root,0755)
%{_javadir}/opensaml-%{version}.jar
%{_javadir}/opensaml.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Mon Feb 16 2009 David Walluck <dwalluck@redhat.com> 0:1.1b-2
- add repolib
- use servlet_2_4_api for (Build)Requires
- fix xml-commons (Build)Requires
- don't own %%{_javadir}
- don't BuildRequires ant-nodeps
- correctly set OPT_JAR_LIST
- don't move java directory as it misses files
- fix mixed-use-of-spaces-and-tabs

* Mon Jan 16 2006 Deepak Bhole <dbhole@redhat.com> 0:1.1b-1jpp
- First jpp build.
